/**
 * vC[\NXB
 */
public class Player
{
	/** O */
	private String name_;

	/** e[u */
	Table table_;

	/** D */
	Hand myHand_ = new Hand();

	/** is */
	Master master_;

	/** pX */
	int pass_;

	/**
	 * RXgN^B
	 * 
	 * @param name O
	 * @param master is
	 * @param table e[u
	 */
	public Player(String name, Master master, Table table)
	{
		this.name_ = name;
		this.master_ = master;
		this.table_ = table;
	}

	/**
	 * ԂwB
	 */
	public void play()
	{
		// ݂̎D\
		System.out.println("  " + myHand_);
		
		// DɂJ[h1`FbNāAɒu邩ׂ
		int handSize = myHand_.getNumberOfCards();
		for (int position = 0; position < handSize; position++)
		{
			// DɂJ[h
			Card lookingCard = myHand_.lookCard(position);

			int number = lookingCard.getNumber();
			int suit = lookingCard.getSuit();

			// ڂĂD̍EɃJ[h΁AJ[hu
			int leftNumber = (number != 1) ? number - 1 : 13;
			int rightNumber = (number != 13) ? number + 1 : 1;

			if ((true == table_.isThereCard(suit, leftNumber))
				|| (true == table_.isThereCard(suit, rightNumber)))
			{
				// DJ[hăe[uɒu
				table_.putCard(myHand_.pickCard(position));

				// DȂȂAオ錾
				if (myHand_.getNumberOfCards() == 0)
				{
					master_.declareWin(this);
				}

				return;
			}
		}

		// e[uɒuJ[hȂꍇApX
		pass_++;
		master_.pass(this);

		// pX񐔂4ȏȂ΃J[hSăe[uɒu
		if (pass_ > 3)
		{
			// DSăe[uɒu
			for (int count = 0; count < handSize; count++)
			{
				table_.putCard(myHand_.pickCard(0));
			}
		}
	}

	/**
	 * J[h󂯎B
	 * 
	 * @param card 󂯎J[h
	 */
	public void receiveCard(Card card)
	{
		if (card.getNumber() == 7)
		{
			// J[h7̏ꍇ́Ae[uɃJ[hu
			table_.putCard(card);
		}
		else
		{
			// J[h7łȂꍇ́A󂯎J[hD։
			myHand_.addCard(card);
		}
	}

	/**
	 * pX񐔂𕷂B
	 * 
	 * @return pX
	 */
	public int getPass()
	{
		return pass_;
	}

	/**
	 * vC[̖OԂB
	 * ObjectNXtoString\bhI[o[Ch\bhB
	 * 
	 * @return vC[̖O
	 */
	public String toString()
	{
		return name_;
	}
}
