package fantan;

import trump.Card;
import trump.Master;
import trump.Table;
import trump.Hand;
import trump.Player;
import trump.Rule;

/**
 * ׃vOB
 */
public class Fantan
{
    public static void main(String args[])
    {
        // is̐
        Master master = new FantanMaster();
        
        // e[u̐
        Table table = new FantanTable();
        
        // [̐
        Rule rule = new FantanRule();
        
        // vC[̐
        Player murata = new FantanPlayer("c", master, table, rule);
        Player yamada = new FantanPlayer("Rc", master, table, rule);
        Player saito  = new FantanPlayer("֓", master, table, rule);
        
        // vC[o^
        master.registerPlayer(murata);
        master.registerPlayer(yamada);
        master.registerPlayer(saito);
        
        // gv𐶐
        Hand trump = createTrump();
        
        // Q[̏
        master.prepareGame(trump);
        
        // Q[Jn
        master.startGame();
        
    }
    
    /**
     * 53̃gv𐶐B
     * 
     * @return gvi[Deal
     */
    private static Hand createTrump()
    {
        Hand trump = new Hand();
        
        // eX[g53̃J[h𐶐
        for (int number = 1; number <= Card.CARD_NUM; number++)
        {
            trump.addCard(new Card(Card.SUIT_CLUB, number));
            trump.addCard(new Card(Card.SUIT_DIAMOND, number));
            trump.addCard(new Card(Card.SUIT_HEART, number));
            trump.addCard(new Card(Card.SUIT_SPADE, number));
        }
        
        return trump;
    }
}

