package fantan;

import trump.Card;
import trump.Table;
import trump.Hand;
import trump.Rule;

/**
 * חp[NXB
 */
public class FantanRule implements Rule
{
	/**
	 * e[uɒuJ[hTB
	 * 
	 * @param hand D
	 * @param table e[u
	 * @return J[h̑gݍ킹BȂꍇnullԂB
	 */
	public Card[] findCandidate(Hand hand, Table table)
	{
		// e[uɒuJ[ȟ
		Card[] candidate = null;

		// DɂJ[h1`FbNāAe[uɒu邩ׂ
		int numberOfHand = hand.getNumberOfCards();
		for (int position = 0; position < numberOfHand; position++)
		{
			// DɂJ[h
			Card lookingCard = hand.lookCard(position);
			int number = lookingCard.getNumber();
			int suit = lookingCard.getSuit();

			// ڂĂD̍EɃJ[h΁AJ[hu
			int leftNumber = (number != 1) ? number - 1 : Card.CARD_NUM;
			int rightNumber = (number != Card.CARD_NUM) ? number + 1 : 1;

			if ((true == isThereCard(table, suit, leftNumber))
				|| (true == isThereCard(table, suit, rightNumber)))
			{
				// DJ[hČƂ
				candidate = new Card[1];
				candidate[0] = hand.pickCard(position);
				break;
			}
		}

		return candidate;
	}

	/**
	 * e[uɃJ[huĂ邩ׂB
	 * 
	 * @param table e[u
	 * @param suit X[g
	 * @param number 
	 * @return J[huĂꍇtrue
	 */
	private boolean isThereCard(Table table, int suit, int number)
	{
		// e[uɂJ[h𒲂ׁAJ[huĂ邩ׂ
		Card[][] cards = table.getCards();
		if (cards[suit - 1][number - 1] != null)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}
