package oldmaid;

import trump.Card;
import trump.Master;
import trump.Table;
import trump.Hand;
import trump.Joker;
import trump.Player;
import trump.Rule;

/**
 * ΂ΔvOB
 */
public class OldMaid
{
	public static void main(String args[])
	{
		// is̐
		Master master = new Master();

		// e[u̐
		Table table = new OldMaidTable();
		
		// [̐
		Rule rule = new OldMaidRule();
		
		// vC[̐
		Player murata = new OldMaidPlayer("c", master, table, rule);
		Player yamada = new OldMaidPlayer("Rc", master, table, rule);
		Player saito = new OldMaidPlayer("֓", master, table, rule);

		// vC[o^
		master.registerPlayer(murata);
		master.registerPlayer(yamada);
		master.registerPlayer(saito);

		// gv𐶐
		Hand trump = createTrump();

		// Q[̏
		master.prepareGame(trump);

		// Q[Jn
		master.startGame();

	}

	/**
	 * 53̃gv𐶐B
	 * 
	 * @return gvi[Deal
	 */
	private static Hand createTrump()
	{
		Hand trump = new Hand();

		// eX[g53̃J[h𐶐
		for (int number = 1; number <= Card.CARD_NUM; number++)
		{
			trump.addCard(new Card(Card.SUIT_CLUB, number));
			trump.addCard(new Card(Card.SUIT_DIAMOND, number));
			trump.addCard(new Card(Card.SUIT_HEART, number));
			trump.addCard(new Card(Card.SUIT_SPADE, number));
		}

		// W[J[̍쐬
		trump.addCard(new Joker());

		return trump;
	}
}
