package fantan;

import trump.Card;
import trump.Master;
import trump.Table;
import trump.Player;
import trump.Rule;

/**
 * חpvC[NXB
 */
public class FantanPlayer extends Player
{
    /** pX */
    private int pass_;

    /**
     * RXgN^B
     * 
     * @param name    vC[̖O
     * @param master is
     * @param table  e[u
     * @param rule    [
     */
    public FantanPlayer(String name, Master master, Table table, Rule rule)
    {
        super(name, master, table, rule);
    }

    /**
     * J[hzB
     * 
     * @param card 󂯎J[h
     */
    public void receiveCard(Card card)
    {
        if (card.getNumber() == 7)
        {
            // J[h7̏ꍇ́Ae[uɃJ[hu
            System.out.println(name_ + "F" + card + "u܂B");
            table_.putCard(new Card[] { card });
        }
        else
        {
            // J[h7łȂꍇ́A󂯎J[hD։
            super.receiveCard(card);
        }
    }

    /**
     * ԂwB
     * 
     * @param nextPlayer ̃vC[
     */
    public void play(Player nextPlayer)
    {
        // ݂̎D\
        System.out.println("  " + myHand_);

        // ݂̎De[uɏôT
        Card[] candidate = rule_.findCandidate(myHand_, table_);

        // ₪ꍇ̓e[uɏo
        if (candidate != null)
        {
            System.out.println("  " + candidate[0] + "u܂B\n");
            table_.putCard(candidate);
            
            // e[ȕԂ\
            System.out.println(table_);

            // DȂȂAオ錾
            if (myHand_.getNumberOfCards() == 0)
            {
                master_.declareWin(this);
            }
        }
        else
        {
            // e[uɏoJ[hȂꍇApX
            pass_++;
            ((FantanMaster)master_).pass(this);

            // pX񐔂񐔈ȏȂ΃J[hSăe[uɒu
            if (pass_ > FantanMaster.PASS_LIMIT)
            {
                int numberOfHand = myHand_.getNumberOfCards();
                // DSăe[uɒu
                for (int count = 0; count < numberOfHand; count++)
                {
                    table_.putCard(new Card[] { myHand_.pickCard(0)});
                }
            }
        }
    }

    /**
     * pX񐔂B
     * 
     * @return pX
     */
    public int getPass()
    {
        return pass_;
    }
}
