package oldmaid;

import trump.Card;
import trump.Master;
import trump.Table;
import trump.Player;
import trump.Rule;

/**
 * ΂Δ̃vC[NXB
 */
public class OldMaidPlayer extends Player
{
    /** 猩D\NX */
    private BackHand backHand_ = new BackHand(myHand_);

    /**
     * RXgN^B
     * 
     * @param name   O
     * @param master is
     * @param table  e[u
     * @param rule   [
     */
    public OldMaidPlayer(String name, Master master, Table table, Rule rule)
    {
        super(name, master, table, rule);
    }

    /**
     * J[hzB
     * 
     * @param card 󂯎J[h
     */
    public void receiveCard(Card card)
    {
        // 󂯎J[hD։
        super.receiveCard(card);

        // [gpăe[uɏoJ[h邩T
        Card[] candidate = rule_.findCandidate(myHand_, table_);

        // e[uɏoJ[hꍇ͏ɏo
        if (candidate != null)
        {
            System.out.print(this +"F");
            table_.putCard(candidate);
        }
    }

    /**
     * ԂwB
     * 
     * @param nextPlayer ̃vC[
     */
    public void play(Player nextPlayer)
    {
        // ̃vC[ɎD񎦂Ă炤
        BackHand nextPlayersHand = ((OldMaidPlayer)nextPlayer).showHand();

        // ̎DJ[hꖇ
        int numberOfHands = nextPlayersHand.getNumberOfCards();
        Card pickedCard =
            nextPlayersHand.pickCard((int) (Math.random() * numberOfHands));

        // ʂ\
        System.out.println(
            this +"F" + nextPlayer + "񂩂 " + pickedCard + "܂");

        // J[h̎Dɉ
        myHand_.addCard(pickedCard);

        // e[uɏoJ[h̑gݍ킹邩T
        Card[] sameCards = rule_.findCandidate(myHand_, table_);

        // J[h̑gݍ킹݂ꍇ
        if (sameCards != null)
        {
            System.out.print(this +"F");
            table_.putCard(sameCards);

            // D[ɂȂǂׂ
            if (myHand_.getNumberOfCards() == 0)
            {
                // isɏオ錾
                master_.declareWin(this);
            }
        }

        // ݂̎D\
        System.out.println(this +"Fc̎D " + myHand_ + "ł");
    }

    /**
     * DoB
     * ɃJ[hĂ炤߂ɁADB
     * 
     * @return ̎D
     */
    public BackHand showHand()
    {
        // ̎_ŎDc1ȂΏオƂȂ̂Ő錾
        if (myHand_.getNumberOfCards() == 1)
        {
            master_.declareWin(this);
        }

        // OɃVbt
        myHand_.shuffle();

        // ɎD𗠂猩邽߁ABackHandԂ
        return backHand_;
    }
}
